/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package in.ac.gpckasargod.student.registration;

import in.ac.gpckasargod.student.registration.constants.MessageConstants;
import in.ac.gpckasargod.student.registration.model.db.Department;
import in.ac.gpckasargod.student.registration.model.db.Registration;
import in.ac.gpckasargod.student.registration.service.DepartmentService;
import in.ac.gpckasargod.student.registration.service.RegistrationService;
import in.ac.gpckasargod.student.registration.service.impl.DepartmentServiceImpl;
import in.ac.gpckasargod.student.registration.service.impl.RegistrationServiceImpl;
import java.util.Calendar;
import java.util.Date;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.SwingUtilities;

/**
 *
 * @author mkabh
 */
public class RegistrationForm extends javax.swing.JPanel {
    

    /**
     * Creates new form RegistrationForm
     */
    
    private DepartmentService departmentService = new DepartmentServiceImpl();;
    private RegistrationService registrationService = new RegistrationServiceImpl();
    private Registration selectedRecord;
    public RegistrationForm() {
        selectedRecord = null;
        initComponents();
        populateDepartmentCombo();
        pupulateGender();
        dteDOB.setDate(new Date());
    }
    
    public RegistrationForm(Registration registration){
        selectedRecord = registration;
        initComponents();
        populateDepartmentCombo();
        pupulateGender();
        Department department = departmentService.readDepartment(registration.getDepartmentId());
        txtName.setText(registration.getName());
        txtAdmissionNo.setText(registration.getAdmissionNo());
        txtRegNo.setText(registration.getRegNo());
        txtEmail.setText(registration.getEmailId());
        cboGender.setSelectedItem(registration.getGender());
        cboDepartment.setSelectedItem(department);
        dteDOB.setDate(registration.getDob());
    }
    
    private void populateDepartmentCombo(){
        cboDepartment.removeAllItems();
        //cboDepartment.addItem("CT-Computer Engineering");
        //cboDepartment.addItem("ME-Mechanical Engineering");
        
        Department[] departments = departmentService.getAllDepartments();
        DefaultComboBoxModel model = new DefaultComboBoxModel();
        cboDepartment.setModel(model);
        for(Department department:departments){
            //cboDepartment.addItem(department.getShortName()+"-"+department.getName());
            model.addElement(department);
        }
    }
    
    private void pupulateGender(){
        cboGender.removeAllItems();
        cboGender.addItem("Male");
        cboGender.addItem("Fe Male");
        
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        lblName = new javax.swing.JLabel();
        txtName = new javax.swing.JTextField();
        lblAdmissionNo = new javax.swing.JLabel();
        txtAdmissionNo = new javax.swing.JTextField();
        lblRegNo = new javax.swing.JLabel();
        txtRegNo = new javax.swing.JTextField();
        lblDepartment = new javax.swing.JLabel();
        cboDepartment = new javax.swing.JComboBox<>();
        lblGender = new javax.swing.JLabel();
        cboGender = new javax.swing.JComboBox<>();
        lblDob = new javax.swing.JLabel();
        lblEmailId = new javax.swing.JLabel();
        txtEmail = new javax.swing.JTextField();
        btnSave = new javax.swing.JButton();
        jLabel8 = new javax.swing.JLabel();
        dteDOB = new com.toedter.calendar.JDateChooser();

        lblName.setText("Name");

        lblAdmissionNo.setText("Admission No");

        lblRegNo.setText("Reg No");

        lblDepartment.setText("Department");

        cboDepartment.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));

        lblGender.setText("Gender");

        cboGender.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));

        lblDob.setText("DOB");

        lblEmailId.setText("Email Id");

        btnSave.setText("Save");
        btnSave.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnSaveActionPerformed(evt);
            }
        });

        jLabel8.setFont(new java.awt.Font("Tahoma", 0, 14)); // NOI18N
        jLabel8.setText("Student Registration");

        dteDOB.setDateFormatString("dd-MM-yyyy");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(140, 140, 140)
                .addComponent(jLabel8)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(btnSave, javax.swing.GroupLayout.PREFERRED_SIZE, 77, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(0, 0, Short.MAX_VALUE))
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(lblName)
                            .addComponent(lblAdmissionNo)
                            .addComponent(lblDepartment)
                            .addComponent(lblDob)
                            .addComponent(lblEmailId))
                        .addGap(22, 22, 22)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(txtEmail)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(dteDOB, javax.swing.GroupLayout.PREFERRED_SIZE, 166, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(lblGender)
                                .addGap(31, 31, 31)
                                .addComponent(cboGender, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(txtAdmissionNo, javax.swing.GroupLayout.PREFERRED_SIZE, 98, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(14, 14, 14)
                                .addComponent(lblRegNo)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 50, Short.MAX_VALUE)
                                .addComponent(txtRegNo, javax.swing.GroupLayout.PREFERRED_SIZE, 98, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addComponent(txtName)
                            .addComponent(cboDepartment, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel8)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 25, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lblName)
                    .addComponent(txtName, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lblAdmissionNo)
                    .addComponent(txtAdmissionNo, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(lblRegNo)
                    .addComponent(txtRegNo, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(23, 23, 23)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lblDepartment)
                    .addComponent(cboDepartment, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(lblGender)
                        .addComponent(cboGender, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(lblDob))
                    .addComponent(dteDOB, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(28, 28, 28)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lblEmailId)
                    .addComponent(txtEmail, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(26, 26, 26)
                .addComponent(btnSave)
                .addContainerGap())
        );
    }// </editor-fold>//GEN-END:initComponents

    private void btnSaveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnSaveActionPerformed

        // TODO add your handling code here:
        String message = "";
        Registration registration = new Registration();
        registration.setAdmissionNo(txtAdmissionNo.getText());
        registration.setName(txtName.getText());
        registration.setRegNo(txtRegNo.getText());
        registration.setEmailId(txtEmail.getText());
        registration.setGender(cboGender.getSelectedItem().toString());
        Department department = (Department)cboDepartment.getSelectedItem();
        registration.setDepartmentId(department.getId());
        registration.setDob(dteDOB.getDate());
        
        if(selectedRecord != null){
            registration.setId(selectedRecord.getId());
            System.out.println(registration);
            message = registrationService.updateRegistration(registration);
        }else{
            System.out.println(registration);
            message = registrationService.saveRegistration(registration);
        }
        
        JOptionPane.showMessageDialog(this, message);
        if(message.equalsIgnoreCase(MessageConstants.MESSAGE_SAVE_SUCCESS) || message.equalsIgnoreCase(MessageConstants.MESSAGE_UPDATE_SUCCESS)){
            JFrame frame = (JFrame) SwingUtilities.getWindowAncestor(this);
            frame.dispose();
        }
        
    }//GEN-LAST:event_btnSaveActionPerformed


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnSave;
    private javax.swing.JComboBox<String> cboDepartment;
    private javax.swing.JComboBox<String> cboGender;
    private com.toedter.calendar.JDateChooser dteDOB;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel lblAdmissionNo;
    private javax.swing.JLabel lblDepartment;
    private javax.swing.JLabel lblDob;
    private javax.swing.JLabel lblEmailId;
    private javax.swing.JLabel lblGender;
    private javax.swing.JLabel lblName;
    private javax.swing.JLabel lblRegNo;
    private javax.swing.JTextField txtAdmissionNo;
    private javax.swing.JTextField txtEmail;
    private javax.swing.JTextField txtName;
    private javax.swing.JTextField txtRegNo;
    // End of variables declaration//GEN-END:variables
}
